
/* Copyright (C) 1986-2000 by Digital Mars.
 * All Rights Reserved
 * www.digitalmars.com
 */

#if __SC__ || __RCC__
#pragma once
#endif

#ifndef __MATH_H
#define __MATH_H 1

#if __cplusplus
extern "C" {
#endif

/* Define _CRTAPI1 (for compatibility with the NT SDK) */
#ifndef _CRTAPI1
#define _CRTAPI1 __cdecl
#endif

/* Define _CRTAPI2 (for compatibility with the NT SDK) */
#ifndef _CRTAPI2
#define _CRTAPI2 __cdecl
#endif

/* Define CRTIMP */
#ifndef _CRTIMP
#if defined(_WIN32) && defined(_DLL)
#define _CRTIMP  __declspec(dllimport)
#else
#define _CRTIMP
#endif
#endif

#if __ZTC__ < 0x220
#define HUGE_VAL	1.797693134862315e+308
#else
#define HUGE_VAL	__inf
#endif

#if __OS2__ && __INTSIZE == 4
#define __CLIB	__stdcall
#else
#define __CLIB	__cdecl
#endif

double	__CLIB acos(double);
double	__CLIB asin(double);
double	__CLIB atan(double);
double	__CLIB atan2(double,double);
double	__CLIB cos(double);
double	__CLIB sin(double);
double	__CLIB tan(double);
double	__CLIB cosh(double);
double	__CLIB sinh(double);
double	__CLIB tanh(double);
double	__CLIB exp(double);
double	__CLIB frexp(double,int *);
double	__CLIB ldexp(double,int);
double	__CLIB log(double);
double	__CLIB log10(double);
double	__CLIB modf(double,double *);
double	__CLIB pow(double,double);
double	__CLIB sqrt(double);
double	__CLIB ceil(double);
double	__CLIB fabs(double);
double	__CLIB floor(double);
double	__CLIB fmod(double,double);
int	__CLIB abs(int);
long    __CLIB labs(long);

#if __ZTC__ >= 0x302
double	__CLIB _inline_fabs(double);
#define fabs(d) _inline_fabs(d)

#if __INLINE_8087
double	__CLIB _inline_sqrt(double);
#define sqrt(d) _inline_sqrt(d)
#if __SC__ >= 0x760 && __I86__ >= 3
double	__CLIB _inline_sin(double);
#define sin(d) _inline_sin(d)
double	__CLIB _inline_cos(double);
#define cos(d) _inline_cos(d)
#endif
#endif
#endif

float	__CLIB acosf(float);
float	__CLIB asinf(float);
float	__CLIB atanf(float);
float	__CLIB atan2f(float,float);
float	__CLIB cosf(float);
float	__CLIB sinf(float);
float	__CLIB tanf(float);
float	__CLIB coshf(float);
float	__CLIB sinhf(float);
float	__CLIB tanhf(float);
float	__CLIB expf(float);
float	__CLIB frexpf(float,int *);
float	__CLIB ldexpf(float,int);
float	__CLIB logf(float);
float	__CLIB log10f(float);
float	__CLIB modff(float,float *);
float	__CLIB powf(float,float);
float	__CLIB sqrtf(float);
float	__CLIB ceilf(float);
float	__CLIB fabsf(float);
float	__CLIB floorf(float);
float	__CLIB fmodf(float,float);
float	__CLIB log1pf(float);
float	__CLIB expm1f(float);

#ifndef __STDC__

double	__CLIB log1p(double);
double	__CLIB expm1(double);

long double __CLIB expl(long double);

#if __ZTC__ >= 0x302
float	__CLIB _inline_fabsf(float);
#define fabsf(f) _inline_fabsf(f)

#if __INLINE_8087
float	__CLIB _inline_sqrtf(float);
#define sqrtf(f) _inline_sqrtf(f)
#if __SC__ >= 0x760 && __I86__ >= 3
double	__CLIB _inline_sinf(float);
#define sinf(f) _inline_sinf(f)
double	__CLIB _inline_cosf(float);
#define cosf(f) _inline_cosf(f)
#endif
#endif
#endif

#define acosl	acos
#define asinl	asin
#define _asinl	asinl
#define atanl	atan
#define _atanl	atanl
#define atan2l	atan2
#define _atan2l	atan2l
#define cosl	cos
#define _cosl	cos
#define sinl	sin
#define _sinl	sin
#define tanl	tan
#define _tanl	tan
#define coshl	cosh
#define _coshl	cosh
#define sinhl	sinh
#define _sinhl	sinh
#define tanhl	tanh
#define _tanhl	tanh
#define expl	exp
#define frexpl	frexp
#define _frexpl	frexp
#define ldexpl	ldexp
#define _ldexpl	ldexp
#define logl	log
#define _logl	log
#define log10l	log10
#define _log10l	log10
#define modfl	modf
#define _modfl	modf
#define powl	pow
#define _powl	pow
#define sqrtl	sqrt
#define _sqrtl	sqrt
#define ceill	ceil
#define _ceill ceil
#define fabsl	fabs
#define _fabsl	fabs
#define floorl	floor
#define _floorl	floor
#define fmodl	fmod
#define _fmodl	fmod
#define log1pl	log1p
#define expm1l	expm1
#define _expl	expl
#define _matherrl _matherr

#define PI		3.14159265358979323846
#define LOG2		0.30102999566398119521
#define LN2		0.6931471805599453094172321
#define LOG2T		3.32192809488736234787
#define LOG2E		1.4426950408889634074

#define	M_LOG2E		LOG2E
#define	M_LN2		LN2
#define	M_PI		PI
#define	M_E		2.7182818284590452354
#define	M_LOG10E	0.43429448190325182765
#define	M_LN10		2.30258509299404568402
#define	M_PI_2		1.57079632679489661923
#define	M_PI_4		0.78539816339744830962
#define	M_1_PI		0.31830988618379067154
#define	M_2_PI		0.63661977236758134308
#define	M_2_SQRTPI	1.12837916709551257390
#define	M_SQRT2		1.41421356237309504880
#define	M_SQRT1_2	0.70710678118654752440

#ifndef _EXCEPTION_DEFINED

struct _exception
{	int type;
	char *name;
	double arg1;
	double arg2;
	double retval;
};

#if !__STDC__
#define exception _exception
#endif

#define _exceptionl _exception

#define _EXCEPTION_DEFINED
#endif 


#define _DOMAIN		1
#define _SING		2
#define	_OVERFLOW	3
#define _UNDERFLOW	4
#define _TLOSS		5
#define _PLOSS		6

#define EDOM            33
#define ERANGE          34

#ifndef __STDC__
#define DOMAIN		_DOMAIN
#define SING		_SING
#define	OVERFLOW	_OVERFLOW
#define UNDERFLOW	_UNDERFLOW
#define TLOSS		_TLOSS
#define PLOSS		_PLOSS
#define DIVIDE_BY_ZERO  7
#endif

int	__CLIB matherr(struct exception *);
double	__CLIB atof(const char *);
#define _atold atof
#define _matherr matherr
double	__CLIB hypot(double,double);
#define	_hypot	hypot
#define	_hypotl	hypot
#define	hypotl	hypot
double	__CLIB poly(double,int,double []);
#define polyl poly
double _poly87(double, int, double []);

#if __INLINE_8087
#define poly _poly87
#endif

#if 0
#if !__cplusplus

struct complex
{
   double x,y;
};

#define cabs(z) (hypot(z.x,z.y))

#define complexl complex
#define _cabs cabs
#define cabsl cabs
#define _cabsl cabs
#define _complex complex
#define _complexl complexl

#endif
#endif

#endif

#if __cplusplus
}
#endif

#endif
